Class | RubyLex::BufferedReader
In: | rdoc/parsers/parse_rb.rb
Parent: | Object

Read an input stream character by character. We allow for unlimited ungetting of characters just read.

We simplify the implementation greatly by reading the entire input into a buffer initially, and then simply traversing it using pointers.

We also have to allow for the here document diversion. This little gem comes about when the lexer encounters a here document. At this point we effectively need to split the input stream into two parts: one to read the body of the here document, the other to read the rest of the input line where the here document was initially encountered. For example, we might have

      do_something(<<-A, <<-B)
        stuff
        for
      A
        stuff
        for
      B

When the lexer encounters the <<A, it reads until the end of the line, and keeps it around for later. It then reads the body of the here document. Once complete, it needs to read the rest of the original line, but then skip the here document body.

### Methods

column divert_read_from get_read getc getc_already_read new peek peek_equal ungetc

### Attributes

line_num | [R] |

### Public Class methods

new(content)

[Source]

    # File rdoc/parsers/parse_rb.rb, line 349
        def initialize(content)
          if /\t/ =~ content
            tab_width = Options.instance.tab_width
            content = content.split(/\n/).map do |line|
              1 while line.gsub!(/\t+/) { ' ' * (tab_width*$&.length - $`.length % tab_width)}  && $~ #`
              line
            end .join("\n")
          end
          @content   = content
          @content << "\n" unless @content[-1,1] == "\n"
          @size      = @content.size
          @offset    = 0
          @hwm       = 0
          @line_num  = 1
          @read_back_offset = 0
          @last_newline = 0
          @newline_pending = false
        end

### Public Instance methods

column()

[Source]

    # File rdoc/parsers/parse_rb.rb, line 368
        def column
          @offset - @last_newline
        end

divert_read_from(reserve)

[Source]

    # File rdoc/parsers/parse_rb.rb, line 422
        def divert_read_from(reserve)
          @content[@offset, 0] = reserve
          @size      = @content.size
        end

get_read()

[Source]

    # File rdoc/parsers/parse_rb.rb, line 403
        def get_read
          res = @content[@read_back_offset...@offset]
          @read_back_offset = @offset
          res
        end

getc()

[Source]

    # File rdoc/parsers/parse_rb.rb, line 372
        def getc
          return nil if @offset >= @size
          ch = @content[@offset, 1]

          @offset += 1
          @hwm = @offset if @hwm < @offset

          if @newline_pending
            @line_num += 1
            @last_newline = @offset - 1
            @newline_pending = false
          end

          if ch == "\n"
            @newline_pending = true
          end
          ch
        end

getc_already_read()

[Source]

    # File rdoc/parsers/parse_rb.rb, line 391
        def getc_already_read
          getc
        end

peek(at)

[Source]

    # File rdoc/parsers/parse_rb.rb, line 409
        def peek(at)
          pos = @offset + at
          if pos >= @size
            nil
          else
            @content[pos, 1]
          end
        end

peek_equal(str)

[Source]

    # File rdoc/parsers/parse_rb.rb, line 418
        def peek_equal(str)
          @content[@offset, str.length] == str
        end

ungetc(ch)

[Source]

    # File rdoc/parsers/parse_rb.rb, line 395
        def ungetc(ch)
          raise "unget past beginning of file" if @offset <= 0
          @offset -= 1
          if @content[@offset] == ?\n
            @newline_pending = false
          end
        end

[Validate]